      subroutine sphere ( x, y, z )
c     ************************************************************
c     **  calculates a random vector on the unit sphere        ***
c     **  M. G. Martin   2-3-98                                ***
c     ************************************************************

      implicit none
      integer ii
      double precision random, x, y, z
      double precision xi1,xi2,xisq

c     --- calculate random vector on the unit sphere ---
      do ii = 1,100
         xi1 = ( 2.0d0 * random() ) - 1.0d0
         xi2 = ( 2.0d0 * random() ) - 1.0d0
         xisq = xi1**2 + xi2**2
         if ( xisq .lt. 1.0d0 ) then
            x = 2.0d0 * xi1 * dsqrt( 1.0d0 - xisq )
            y = 2.0d0 * xi2 * dsqrt( 1.0d0 - xisq )
            z = ( 1.0d0 - 2.0d0 * xisq )
            return
         endif
      enddo

      stop 'exceeded 100 tries to get a vector in sphere'

      end

      
