      subroutine cluster(ntotal,irem,lbroke,lswap)

      implicit none

      include 'control.inc'
      include 'neigh.inc'

      logical lbroke,lswap,lclust(nmax),ldelet(nmax)
      integer m,n,ip,irem,i,j,ntotal,iend,parnum1(nmax),parnum2(nmax)
      
      do m = 1,ntotal
         lclust(m) = .false.
         ldelet(m) = .false.
      enddo

      if ( lswap ) then
         lclust(irem) = .false.
      else
         lclust(irem) = .true.
      endif
      ldelet(irem) = .true.

      if ( lene_cut ) then

         if ( lswap ) then
            
            if ( irem .ne. 1 ) then
               parnum1(1) = 1
               iend = 1
               lclust(1) = .true.
               ldelet(1) = .true.
            else
               parnum1(1) = 2
               iend = 1
               lclust(2) = .true.
               ldelet(2) = .true.
            endif

         else

            j = 0
            do ip = 1,neigh_icnt2
               n = neighi2(ip)
               j = j+1
               parnum1(j) = n
               lclust(n) = .true.
               ldelet(n) = .true.
            enddo
            iend = j
         endif

 24      j = 0
         do i = 1,iend
            m = parnum1(i)
            do ip = 1, neigh_cnt2(m)
               n = neighbor2(ip,m)
               if ( .not. ldelet(n) ) then
                  ldelet(n) = .true.
                  j = j + 1
                  parnum2(j) = n
                  lclust(n) = .true.
               endif
            enddo
         enddo
                  
         iend = j
         do i = 1,iend
            m = parnum2(i)
            parnum1(i) = m
         enddo
               
         if ( iend .ne. 0 ) goto 24
               
      else

         if ( lswap ) then
            
            if ( irem .ne. 1 ) then
               parnum1(1) = 1
               iend = 1
               lclust(1) = .true.
               ldelet(1) = .true.
            else
               parnum1(1) = 2
               iend = 1
               lclust(2) = .true.
               ldelet(2) = .true.
            endif

         else

            j = 0
            do ip = 1,neigh_icnt
               n = neighi(ip)
               j = j+1
               parnum1(j) = n
               lclust(n) = .true.
               ldelet(n) = .true.
            enddo
            iend = j
         endif

 64      j = 0
         do i = 1,iend
            m = parnum1(i)
            do ip = 1, neigh_cnt(m)
               n = neighbor(ip,m)
               if ( .not. ldelet(n) ) then
                  ldelet(n) = .true.
                  j = j + 1
                  parnum2(j) = n
                  lclust(n) = .true.
               endif
            enddo
         enddo
                  
         iend = j
         do i = 1,iend
            m = parnum2(i)
            parnum1(i) = m
         enddo
               
         if ( iend .ne. 0 ) goto 64

      endif

      lbroke = .false.

      if ( lswap ) then
         do m = 1, ntotal
            if ( .not. lclust(m) ) then
               if ( m .ne. irem )
     &              lbroke = .true.
            endif
         enddo
      else
         do m = 1,ntotal
            if ( .not. lclust(m) ) then
               lbroke = .true.
            endif
         enddo
      endif

      return
      end

