C EXTERNAL.INC
      double precision alpha1,alpha2,beta1,beta2
      double precision a1,delta,rsol
      integer ntsubst
      integer tau1,tau2
      logical ljoe,lsami,lexzeo,lpsurf,lzgrid,lmuir,lgraphite
      logical lcorreg
c surfaces:
      parameter (ljoe=.false.,lsami=.false.,lmuir=.false.)
      parameter (lpsurf=.false.)
      parameter (lgraphite=.false.)
      parameter (lcorreg = .false.)
c      parameter (lcorreg = .false.)
c Graphite surface
c -- a1, delta are in Angstroms
c -- rsol [=] 1/A^3
      parameter (a1 = 2.460d0)
      parameter (delta = 3.35d0)
      parameter (ntsubst = 190)
      parameter (rsol = 0.1139168d0)
c zeolites: 
      parameter (lexzeo=.false.,lzgrid=.false.)
c Joe Hautman's parameters are read from standard input:
c               to be used with ljoe = .true. 
c Sami's parameters: to be used with lsami = .true. AND lmuir = .true.
	parameter ( alpha1=21.162d0, alpha2=-21.162d0,
     &              beta1=661.6d0, beta2=6616.0d0,
     &              tau1=-32, tau2=-16 )
c parameters for zeolites are read in subroutine SUZEO
c AT PRESENT no parameters for polymeric surfactants (see LJPSUR)
